const mongoose = require('mongoose').set('debug', false)
const Schema = mongoose.Schema;

const tools = require('../tools/general');

mongoose.Promise = global.Promise;
mongoose.level = "F";


// Resolving error Unknown modifier: $pushAll
mongoose.plugin(schema => {
  schema.options.usePushEach = true
});

const GroupSchema = new Schema({
  idapp: {
    type: String,
  },
  descr: {
    type: String,
  },
  resp: {
    type: String,
  },
  viceResp: {
    type: String,
  },
  assignedToUsers: [
    { type: String }
  ],
});

var Group = module.exports = mongoose.model('Group', GroupSchema);

module.exports.getFieldsForSearch = function () {
  return [{field: 'descr', type: tools.FieldType.string}]
};

module.exports.executeQueryTable = function (idapp, params) {
  params.fieldsearch = this.getFieldsForSearch();
  return tools.executeQueryTable(this, idapp, params);
};

module.exports.findAllIdApp = async function (idapp) {
  const myfind = { idapp };

  return await Group.find(myfind).lean();
};

module.exports.createIndexes()
  .then(() => { })
  .catch((err) => { throw err; });

